diff --git a/src/backend/access/spgist/spgtextproc.c b/src/backend/access/spgist/spgtextproc.c
index b5ec81937c..71c1b6134b 100644
--- a/src/backend/access/spgist/spgtextproc.c
+++ b/src/backend/access/spgist/spgtextproc.c
@@ -186,8 +186,6 @@ spg_text_choose(PG_FUNCTION_ARGS)
 	text	   *inText = DatumGetTextPP(in->datum);
 	char	   *inStr = VARDATA_ANY(inText);
 	int			inSize = VARSIZE_ANY_EXHDR(inText);
-	char	   *prefixStr = NULL;
-	int			prefixSize = 0;
 	int			commonLen = 0;
 	int16		nodeChar = 0;
 	int			i = 0;
@@ -196,6 +194,8 @@ spg_text_choose(PG_FUNCTION_ARGS)
 	if (in->hasPrefix)
 	{
 		text	   *prefixText = DatumGetTextPP(in->prefixDatum);
+	    char	   *prefixStr;
+	    int			prefixSize;
 
 		prefixStr = VARDATA_ANY(prefixText);
 		prefixSize = VARSIZE_ANY_EXHDR(prefixText);